 .CODE
GetPrinterDC:                  ;GetPrinterDC(void)
                               ;enter with EBP=0

GETPDC STRUC                   ;tailor this structure to the subroutine
 dwNeeded   DD ?               ;local variable
 dwReturned DD ?               ;local variable
 hdc        DD ?               ;local variable
 pinfo      DD ?               ;local variable
GETPDC ENDS

GPDC EQU ESP.GETPDC            ;save some typing

 SUB ESP,GETPDC                ;make local storage

 LEA ECX,[GPDC.dwNeeded]
 LEA EDX,[GPDC.dwReturned]

 RPUSHIT ECX,EDX,\ ;***push for first EnumPrinters below
         ECX,EDX   ;***push for second EnumPrinters below

 INVOKE GetVersion
 TEST EAX,EAX
 .IF SIGN?                               ;if Windows 98
   INVOKIT EnumPrinters,PRINTER_ENUM_DEFAULT,EBP,5,EBP,EBP ;***last two parameters pushed above

   INVOKIT LocalAlloc,LMEM_FIXED,[GPDC.dwNeeded+2*DWORD]
   MOV [GPDC.pinfo+2*DWORD],EAX          ;***compensate 2*DWORD for unbalanced stack

   INVOKIT EnumPrinters,PRINTER_ENUM_DEFAULT,EBP,5,EAX,[GPDC.dwNeeded+2*DWORD] ;***last two parameters pushed above

   MOV EAX,[GPDC.pinfo]                  ;EAX=pointer to PRINTER_INFO_5 structure
   INVOKE CreateDC,EBP,[EAX.PRINTER_INFO_5.pPrinterName],EBP,EBP
 .ELSE                                   ;if Windows NT
   INVOKIT EnumPrinters,PRINTER_ENUM_LOCAL,EBP,4,EBP,EBP ;***last two parameters pushed above

   INVOKIT LocalAlloc,LMEM_FIXED,[GPDC.dwNeeded+2*DWORD]
   MOV [GPDC.pinfo+2*DWORD],EAX          ;***compensate 2*DWORD for unbalanced stack

   INVOKIT EnumPrinters,PRINTER_ENUM_LOCAL,EBP,4,EAX,[GPDC.dwNeeded+2*DWORD] ;***last two parameters pushed above

   MOV EAX,[GPDC.pinfo]                  ;EAX=pointer to PRINTER_INFO_4 structure
   INVOKE CreateDC,EBP,[EAX.PRINTER_INFO_4.pPrinterName],EBP,EBP
 .ENDIF

 MOV [GPDC.hdc],EAX                      ;from CreateDC

 INVOKE LocalFree,[GPDC.pinfo]

 MOV EAX,[GPDC.hdc] ;return hdc
 ADD ESP,GETPDC     ;reclaim local storage
 RET                ;return to sender
;_______________________________________________________________________________
PrintMyPage:           ;PrintMyPage(hwnd)
                       ;enter with EBP=0

 PMP STRUC             ;tailor this structure to the subroutine
ADR1 = $
 bSuccess DWORD ?      ;local variable
 xPage    DWORD ?      ;local variable
 yPage    DWORD ?      ;local variable
ADR2 = $
           DWORD ?     ;register save
           DWORD ?     ;register save
 return   DWORD ?
ADR3 = $
 hwnd     DWORD ?      ;parameter
ADR4 = $
 PMP ENDS

 .DATA
DINFOSTR BYTE 'Print3: Printing',0
 docinfo DOCINFO {DOCINFO,@ DINFOSTR} ;DOCINFO structure

 .CODE
 RPUSHIT ESI,EDI            ;save registers
 SUB ESP,ADR2-ADR1          ;make room for local storage

 MOV [ESP.PMP.bSuccess],ESP ;ESP=TRUE<>0

 INVOKIT GetPrinterDC
 TEST EAX,EAX               ;device context failure?
 JZ PMPRET                  ;return false on device context failure

 MOV EDI,EAX                ;EDI=hdcPrn
 MOV ESI,[ESP.PMP.hwnd]     ;ESI=hwnd

 INVOKE GetDeviceCaps,EDI,HORZRES ;EDI=hdcPrn
 MOV [ESP.PMP.xPage],EAX
 INVOKE GetDeviceCaps,EDI,VERTRES ;EDI=hdcPrn
 MOV [ESP.PMP.yPage],EAX

 INVOKE EnableWindow,ESI,EBP      ;ESI=hwnd,EDI=hdcPrn

 MOV [bUserAbort],EBP       ;EBP=0=FALSE

 INVOKE CreateDialogParam,[hInst],BYTER('PRINTDLGBOX',0),ESI,@ PrintDlgProc,EBP
 MOV [hDlgPrint],EAX

 INVOKE SetAbortProc,EDI,@ AbortProc

 IF DBUG
  .IF SD EAX <= EBP     ;EBP=0
    INVOKE MessageBox,ESI,BYTER('SetAbortProc call error',0),EBP,EBP ;EBP=0
    INVOKE ExitProcess,EAX
  .ENDIF
 ENDIF

 INVOKE StartDoc,EDI,@ docinfo
 .IF SD EAX > EBP       ;EBP=0
   INVOKE StartPage,EDI ;EDI=hdcPrn
   .IF SD EAX > EBP     ;EBP=0
     INVOKIT PageGDICalls,EDI,[ESP.PMP.xPage+1*DWORD],[ESP.PMP.yPage]
     INVOKE EndPage,EDI ;EDI=hdcPrn
     .IF SD EAX > EBP   ;EBP=0
       INVOKE EndDoc,EDI
     .ELSE
       MOV [ESP.PMP.bSuccess],EBP ;EBP=0=FALSE
     .ENDIF
   .ENDIF
 .ELSE
   MOV [ESP.PMP.bSuccess],EBP     ;EBP=0=FALSE
 .ENDIF

 .IF [bUserAbort] == EBP                    ;EBP=0
   INVOKE EnableWindow,ESI,ESP            ;ESI=hwnd,ESP=TRUE<>0
   INVOKE DestroyWindow,[hDlgPrint]
 .ENDIF

 INVOKE DeleteDC,EDI

 XOR EAX,EAX       ;EAX=0=FALSE
 .IF ([ESP.PMP.bSuccess] != EBP) && ([bUserAbort] == EBP) ;EBP=0
   INC EAX         ;EAX=1=TRUE
 .ENDIF

PMPRET:
 ADD ESP,ADR2-ADR1 ;restore local variable storage
 POPIT ESI,EDI     ;restore registers
 RET ADR4-ADR3     ;return and balance stack
;_______________________________________________________________________________
PageGDICalls:               ;PageGDICalls(hdcPrn,cxPage,cyPage)
                            ;enter with EBP=0

PGDIC STRUC                 ;tailor this struct to the subroutine
 return DWORD ?
ADR3 = $
 hdcPrn DWORD ?             ;parameter
 cxPage DWORD ?             ;parameter
 cyPage DWORD ?             ;parameter
ADR4 = $
PGDIC ENDS

 MOV EDI,[ESP.PGDIC.hdcPrn] ;EDI=hdcPrn
 MOV EAX,[ESP.PGDIC.cxPage] ;EAX=cxPage
 MOV ECX,[ESP.PGDIC.cyPage] ;EAX=cyPage
 SHR EAX,1                  ;EAX=cxPage/2
 SHR ECX,1                  ;EAX=cyPage/2

 RPUSHIT EDI,EAX,ECX,EBP    ;***push for SetViewportOrgEx below
 NEG ECX                    ;ECX=-cyPage/2
 RPUSHIT EDI,EAX,ECX,EBP    ;***push for SetViewportExtEx below
 NEG ECX                    ;ECX=cyPage/2
 SHL EAX,1                  ;EAX=cxPage
 SHL ECX,1                  ;ECX=cyPage
 RPUSHIT EDI,1000,1000,EBP  ;***push for SetWindowExtEx below
 RPUSHIT EDI,MM_ISOTROPIC   ;***push for SetMapMode below
 RPUSHIT EDI                ;***push for SaveDC below
 RPUSHIT EDI,EBP,ECX        ;***push for LineTo below, ECX=cyPage
 RPUSHIT EDI,EAX,EBP,EBP    ;***push for MoveToEx below
 RPUSHIT EDI,EAX,ECX        ;***push for LineTo below, EAX=cxPage
 RPUSHIT EDI,EBP,EBP,EBP    ;***push for MoveToEx below

 INVOKE Rectangle,EDI,EBP,EBP,EAX,ECX ;EDI=hdcPrn,EAX=cxPage,EAX=cyPage,EBP=0
 INVOKIT MoveToEx           ;***parameters pushed above
 INVOKIT LineTo             ;***parameters pushed above
 INVOKIT MoveToEx           ;***parameters pushed above
 INVOKIT LineTo             ;***parameters pushed above
 INVOKIT SaveDC             ;***parameters pushed above
 INVOKIT SetMapMode         ;***parameters pushed above
 INVOKIT SetWindowExtEx     ;***parameters pushed above
 INVOKIT SetViewportExtEx   ;***parameters pushed above
 INVOKIT SetViewportOrgEx   ;***parameters pushed above

 INVOKE Ellipse,EDI,-500,500,500,-500

 INVOKE SetTextAlign,EDI,TA_BASELINE OR TA_CENTER
 INVOKE TextOut,EDI,EBP,EBP,BYTIT(LENTXT1,'HELLO PRINTER!'),LENTXT1
 INVOKE RestoreDC,EDI,-1

 RET ADR4-ADR3              ;return to sender
;_______________________________________________________________________________
